/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1893; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1894; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1895; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1896; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1897; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1898; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3798 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 747 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1899; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 405; /* *vftciv4sf_cconly */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
        return -1;
      *pnum_clobbers = 1;
      return 406; /* *vftciv2df_cconly */

    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 407; /* *vftciv1tf_cconly */

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 408; /* *vftcitf_cconly */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 73:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern19 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern19 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern19 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 763 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* vec_permv16qi */

        default:
          return -1;
        }

    case 83:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 677 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 116; /* vacq */

    case 84:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 690 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 117; /* vacccq */

    case 90:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern53 (x3, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_gfmsum_accumv16qi */

        case E_V4SImode:
          if (pattern53 (x3, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_gfmsum_accumv8hi */

        case E_V2DImode:
          if (pattern53 (x3, 
E_V2DImode, 
E_V4SImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 91:
      if (pattern50 (x3, 
E_V2DImode) != 0
          || !
#line 880 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 147; /* vec_gfmsum_accum_128 */

    case 54:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmalv4si */

        case 3:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 151; /* vec_vmalv2di */

        case 4:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 152; /* vec_vmalv1ti */

        case 5:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 153; /* vec_vmalti */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmahv4si */

        case 3:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 157; /* vec_vmahv2di */

        case 4:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 158; /* vec_vmahv1ti */

        case 5:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 159; /* vec_vmahti */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 161; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 162; /* vec_vmalhv4si */

        case 3:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 163; /* vec_vmalhv2di */

        case 4:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 164; /* vec_vmalhv1ti */

        case 5:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 165; /* vec_vmalhti */

        default:
          return -1;
        }

    case 57:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 166; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 167; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 168; /* vec_vmaev4si */

        case 3:
          if (!(
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 169; /* vec_vmaev2di */

        default:
          return -1;
        }

    case 58:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 170; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 171; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 172; /* vec_vmalev4si */

        case 3:
          if (!(
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 173; /* vec_vmalev2di */

        default:
          return -1;
        }

    case 59:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 174; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 175; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 176; /* vec_vmaov4si */

        case 3:
          if (!(
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 177; /* vec_vmaov2di */

        default:
          return -1;
        }

    case 60:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 178; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 179; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 180; /* vec_vmalov4si */

        case 3:
          if (!(
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 181; /* vec_vmalov2di */

        default:
          return -1;
        }

    case 99:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 237; /* vec_sldv16qi */

        case 1:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 238; /* vec_sldv8hi */

        case 2:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 239; /* vec_sldv4si */

        case 3:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 240; /* vec_sldv2di */

        case 4:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 241; /* vec_sldv1ti */

        case 5:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 242; /* vec_sldti */

        case 6:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 243; /* vec_sldv2df */

        case 7:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 244; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 245; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 246; /* vec_sldtf */

        default:
          return -1;
        }

    case 100:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 247; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 248; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 249; /* vec_sldbv4si */

        case 3:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 250; /* vec_sldbv2di */

        case 4:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 251; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 252; /* vec_sldbti */

        case 6:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 253; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 254; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 255; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 256; /* vec_sldbtf */

        default:
          return -1;
        }

    case 101:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 257; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 258; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 259; /* vec_srdbv4si */

        case 3:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 260; /* vec_srdbv2di */

        case 4:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 261; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 262; /* vec_srdbti */

        case 6:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 263; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 264; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 265; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 266; /* vec_srdbtf */

        default:
          return -1;
        }

    case 107:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 343; /* vsbiq */

    case 108:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 344; /* vsbcbiq */

    case 110:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 359; /* vfaev16qi */

        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 360; /* vfaev8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 361; /* vfaev4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 365; /* vfeev16qi */

        case 1:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 366; /* vfeev8hi */

        case 2:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 367; /* vfeev4si */

        case 3:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 368; /* vfeezv16qi */

        case 4:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 369; /* vfeezv8hi */

        case 5:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 370; /* vfeezv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 371; /* vfenev16qi */

        case 1:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 372; /* vfenev8hi */

        case 2:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 373; /* vfenev4si */

        case 3:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 374; /* vfenezv16qi */

        case 4:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 375; /* vfenezv8hi */

        case 5:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 376; /* vfenezv4si */

        default:
          return -1;
        }

    case 122:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1712 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 392; /* vcdgb */

    case 123:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1744 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 393; /* vcdlgb */

    case 124:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1775 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 394; /* vcgdb */

    case 125:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1808 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 395; /* vclgdb */

    case 126:
      return recog_15 (x1, insn, pnum_clobbers);

    case 128:
      if (pattern57 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1889 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 404; /* vflrd */

    case 132:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 473; /* vfminv4sf */

        case 1:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 474; /* vfminv2df */

        case 2:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 475; /* vfminv1tf */

        case 3:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 476; /* vfmintf */

        default:
          return -1;
        }

    case 133:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 477; /* vfmaxv4sf */

        case 1:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 478; /* vfmaxv2df */

        case 2:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 479; /* vfmaxv1tf */

        case 3:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 480; /* vfmaxtf */

        default:
          return -1;
        }

    case 92:
      return recog_14 (x1, insn, pnum_clobbers);

    case 140:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[0], E_V8HImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2245 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 503; /* vcrnfs_v8hi */

    case 134:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern51 (x3, 
E_V16QImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 506; /* vblendv16qi */

        case E_V8HImode:
          if (pattern51 (x3, 
E_V8HImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 507; /* vblendv8hi */

        case E_V4SImode:
          if (pattern51 (x3, 
E_V4SImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 508; /* vblendv4si */

        case E_V2DImode:
          if (pattern51 (x3, 
E_V2DImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 509; /* vblendv2di */

        case E_V2DFmode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 510; /* vblendv2df */

        case E_V1TImode:
          if (pattern51 (x3, 
E_V1TImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 511; /* vblendv1ti */

        case E_TImode:
          if (pattern51 (x3, 
E_TImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 512; /* vblendti */

        case E_V4SFmode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 513; /* vblendv4sf */

        case E_V1TFmode:
          if (pattern153 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
              || !(
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 514; /* vblendv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern64 (x3, 
E_V1QImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 700; /* subv1qi3 */

    case E_V2QImode:
      if (pattern64 (x3, 
E_V2QImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 701; /* subv2qi3 */

    case E_V4QImode:
      if (pattern64 (x3, 
E_V4QImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 702; /* subv4qi3 */

    case E_V8QImode:
      if (pattern64 (x3, 
E_V8QImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 703; /* subv8qi3 */

    case E_V16QImode:
      if (pattern64 (x3, 
E_V16QImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 704; /* subv16qi3 */

    case E_V1HImode:
      if (pattern64 (x3, 
E_V1HImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 705; /* subv1hi3 */

    case E_V2HImode:
      if (pattern64 (x3, 
E_V2HImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 706; /* subv2hi3 */

    case E_V4HImode:
      if (pattern64 (x3, 
E_V4HImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 707; /* subv4hi3 */

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 708; /* subv8hi3 */

    case E_V1SImode:
      if (pattern64 (x3, 
E_V1SImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 709; /* subv1si3 */

    case E_V2SImode:
      if (pattern64 (x3, 
E_V2SImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 710; /* subv2si3 */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 711; /* subv4si3 */

    case E_V1DImode:
      if (pattern64 (x3, 
E_V1DImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 712; /* subv1di3 */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 713; /* subv2di3 */

    case E_V1TImode:
      if (pattern64 (x3, 
E_V1TImode) != 0
          || !
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 714; /* subv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && nonimmediate_operand (operands[1], E_TImode)
          && 
#line 1137 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 715; /* *subti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 6612 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2238; /* *subti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1869 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1231; /* subv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1869 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1232; /* subv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1869 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1233; /* subv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1869 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1234; /* subtf3_vr */
      if (pnum_clobbers == NULL
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2262; /* subtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2263; /* subfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DFmode) != 0
          || !
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2264; /* subdf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_SFmode) != 0
          || !
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2265; /* subsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2266; /* subtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 6928 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2267; /* subdd3 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case PARALLEL:
          switch (XVECLEN (x4, 0))
            {
            case 1:
              x5 = XEXP (x1, 0);
              if (GET_CODE (x5) == MEM)
                {
                  res = recog_19 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[0] = x5;
              operands[1] = x3;
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              switch (pattern154 (x2))
                {
                case 0:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 581; /* *vec_extractv1qi */

                case 1:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 582; /* *vec_extractv2qi */

                case 2:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 583; /* *vec_extractv4qi */

                case 3:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 584; /* *vec_extractv8qi */

                case 4:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 585; /* *vec_extractv16qi */

                case 5:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 586; /* *vec_extractv1hi */

                case 6:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 587; /* *vec_extractv2hi */

                case 7:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 588; /* *vec_extractv4hi */

                case 8:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 589; /* *vec_extractv8hi */

                case 9:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 590; /* *vec_extractv1si */

                case 10:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 591; /* *vec_extractv2si */

                case 11:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 592; /* *vec_extractv4si */

                case 12:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 593; /* *vec_extractv1di */

                case 13:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 594; /* *vec_extractv2di */

                case 14:
                  if (!nonmemory_operand (operands[1], E_V1SFmode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 595; /* *vec_extractv1sf */

                case 15:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 596; /* *vec_extractv2sf */

                case 16:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 597; /* *vec_extractv4sf */

                case 17:
                  if (!nonmemory_operand (operands[1], E_V1DFmode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 598; /* *vec_extractv1df */

                case 18:
                  if (!nonmemory_operand (operands[1], E_V2DFmode)
                      || !
#line 560 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 599; /* *vec_extractv2df */

                default:
                  return -1;
                }

            case 8:
              if (pattern59 (x4, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
                return -1;
              x7 = XVECEXP (x4, 0, 4);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return -1;
              x8 = XVECEXP (x4, 0, 5);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return -1;
              x9 = XVECEXP (x4, 0, 6);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XVECEXP (x4, 0, 7);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode)
                return -1;
              operands[1] = x3;
              if (!nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 1038 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 2;
              return 679; /* eltswapv8hi */

            case 4:
              if (pattern59 (x4, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (!nonimmediate_operand (operands[0], E_V4SImode)
                      || GET_MODE (x2) != E_V4SImode
                      || !nonimmediate_operand (operands[1], E_V4SImode)
                      || !
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 680; /* eltswapv4si */

                case E_V4SFmode:
                  if (!nonimmediate_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x2) != E_V4SFmode
                      || !nonimmediate_operand (operands[1], E_V4SFmode)
                      || !
#line 1077 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 681; /* eltswapv4sf */

                default:
                  return -1;
                }

            case 2:
              x6 = XVECEXP (x4, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XVECEXP (x4, 0, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (!nonimmediate_operand (operands[0], E_V2DImode)
                      || GET_MODE (x2) != E_V2DImode
                      || !nonimmediate_operand (operands[1], E_V2DImode)
                      || !
#line 1107 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 682; /* eltswapv2di */

                case E_V2DFmode:
                  if (!nonimmediate_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x2) != E_V2DFmode
                      || !nonimmediate_operand (operands[1], E_V2DFmode)
                      || !
#line 1107 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 683; /* eltswapv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          operands[1] = x3;
          x13 = XEXP (x4, 0);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x12, 0, 0);
          operands[3] = x14;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern154 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 600; /* *vec_extractv1qi_plus */

            case 1:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 601; /* *vec_extractv2qi_plus */

            case 2:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 602; /* *vec_extractv4qi_plus */

            case 3:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 603; /* *vec_extractv8qi_plus */

            case 4:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 604; /* *vec_extractv16qi_plus */

            case 5:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 605; /* *vec_extractv1hi_plus */

            case 6:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 606; /* *vec_extractv2hi_plus */

            case 7:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 607; /* *vec_extractv4hi_plus */

            case 8:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 608; /* *vec_extractv8hi_plus */

            case 9:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 609; /* *vec_extractv1si_plus */

            case 10:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 610; /* *vec_extractv2si_plus */

            case 11:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 611; /* *vec_extractv4si_plus */

            case 12:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 612; /* *vec_extractv1di_plus */

            case 13:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 613; /* *vec_extractv2di_plus */

            case 14:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 614; /* *vec_extractv1sf_plus */

            case 15:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 615; /* *vec_extractv2sf_plus */

            case 16:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 616; /* *vec_extractv4sf_plus */

            case 17:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 617; /* *vec_extractv1df_plus */

            case 18:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 577 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 618; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x15 = XEXP (x3, 0);
      operands[1] = x15;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern166 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 491; /* *vec_extract_bswap_vecv8hi */

        case E_SImode:
          if (pattern166 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 492; /* *vec_extract_bswap_vecv4si */

        case E_SFmode:
          if (pattern166 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 493; /* *vec_extract_bswap_vecv4sf */

        case E_DImode:
          if (pattern166 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 494; /* *vec_extract_bswap_vecv2di */

        case E_DFmode:
          if (pattern166 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 495; /* *vec_extract_bswap_vecv2df */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_20 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern169 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 621; /* *vec_splatv16qi */

        case E_V8HImode:
          if (pattern169 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 622; /* *vec_splatv8hi */

        case E_V4SImode:
          if (pattern169 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 623; /* *vec_splatv4si */

        case E_V4SFmode:
          if (pattern169 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 624; /* *vec_splatv4sf */

        case E_V2DImode:
          if (pattern169 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 625; /* *vec_splatv2di */

        case E_V2DFmode:
          if (pattern169 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 612 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 626; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 627; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 628; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 629; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 630; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 631; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 632; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 653 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 643; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 666 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 644; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 696 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 646; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern84 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 644 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 638; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern84 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 644 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 639; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern84 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 644 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 640; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern84 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 644 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 641; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern84 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 644 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 642; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern136 (x3, 
E_V4SFmode) != 0
              || !(
#line 1932 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1247; /* fmav4sf4 */

        case E_V2DFmode:
          if (pattern136 (x3, 
E_V2DFmode) != 0
              || !
#line 1932 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1248; /* fmav2df4 */

        case E_V1TFmode:
          if (pattern136 (x3, 
E_V1TFmode) != 0
              || !(
#line 1932 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1249; /* fmav1tf4 */

        case E_TFmode:
          if (pattern136 (x3, 
E_TFmode) != 0
              || !(
#line 1932 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1250; /* fmatf4 */

        case E_DFmode:
          if (pattern137 (x3, 
E_DFmode) != 0
              || !
#line 7591 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2325; /* fmadf4 */

        case E_SFmode:
          if (pattern137 (x3, 
E_SFmode) != 0
              || !
#line 7591 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2326; /* fmasf4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern138 (x3, 
E_V4SFmode) != 0
              || !(
#line 1942 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1251; /* fmsv4sf4 */

        case E_V2DFmode:
          if (pattern138 (x3, 
E_V2DFmode) != 0
              || !
#line 1942 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1252; /* fmsv2df4 */

        case E_V1TFmode:
          if (pattern138 (x3, 
E_V1TFmode) != 0
              || !(
#line 1942 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1253; /* fmsv1tf4 */

        case E_TFmode:
          if (pattern138 (x3, 
E_TFmode) != 0
              || !(
#line 1942 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1254; /* fmstf4 */

        case E_DFmode:
          if (pattern139 (x3, 
E_DFmode) != 0
              || !
#line 7608 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2327; /* fmsdf4 */

        case E_SFmode:
          if (pattern139 (x3, 
E_SFmode) != 0
              || !
#line 7608 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2328; /* fmssf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9309 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2445; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9309 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2446; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2447; /* *absdi2_cconly */

        case 1:
          if (!
#line 9320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2448; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern89 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4826 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 1998; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 8258 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2361; /* *nc */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern214 (x3, 
E_TImode) != 0
              || !
#line 6065 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2190; /* *addti3 */

        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 6156 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2195; /* *adddi3_31z */
          if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2197; /* *adddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          return 2198; /* *addsi3 */

        case E_TFmode:
          if (pattern214 (x3, 
E_TFmode) != 0
              || !(
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2220; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern214 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2221; /* addfprx23 */

        case E_DFmode:
          if (pattern214 (x3, 
E_DFmode) != 0
              || !
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2222; /* adddf3 */

        case E_SFmode:
          if (pattern214 (x3, 
E_SFmode) != 0
              || !
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2223; /* addsf3 */

        case E_TDmode:
          if (pattern214 (x3, 
E_TDmode) != 0
              || !(
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2224; /* addtd3 */

        case E_DDmode:
          if (pattern214 (x3, 
E_DDmode) != 0
              || !(
#line 6483 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2225; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 6105 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2191; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6391 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 2215; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2196; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6144 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2194; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern247 (x3, 
E_DImode) != 0
              || !
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2290; /* *adddi3_alc */

        case E_SImode:
          if (pattern247 (x3, 
E_SImode) != 0)
            return -1;
          return 2291; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 62)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern223 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern223 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern223 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern223 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern223 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 92)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern260 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 486; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern260 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 487; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern260 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 488; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern260 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 489; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern260 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 490; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern190 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 634 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 633; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern190 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 634 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 634; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern190 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 634 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 635; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern190 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 634 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 636; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern190 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 634 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 637; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern164 (x6))
        {
        case 0:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1559; /* *bswapv8hi */

        case 1:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1560; /* *bswapv4si */

        case 2:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1561; /* *bswapv4sf */

        case 3:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1562; /* *bswapv2di */

        case 4:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1563; /* *bswapv2df */

        case 5:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1564; /* *bswapv1ti */

        case 6:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1565; /* *bswapv1tf */

        case 7:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1566; /* *bswapti */

        case 8:
          if (!
#line 3330 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1567; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_111 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1884; /* *movstr */

        case 1:
          if (!
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1885; /* *movstr */

        case 2:
          if (!(
#line 3951 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1902; /* *setmem_long */

        case 3:
          if (!(
#line 3951 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1903; /* *setmem_long */

        case 4:
          if (!
#line 3979 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1906; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3964 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1904; /* *setmem_long_and */

        case 6:
          if (!(
#line 3964 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1905; /* *setmem_long_and */

        case 7:
          if (!
#line 3991 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1907; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0L)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10609 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2556; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10609 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2557; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10626 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2558; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10626 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2559; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern15 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10931 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2572; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10931 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2573; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern15 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11869 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2621; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11869 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2622; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_119 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_112 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_113 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_114 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_115 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_116 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern6 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern298 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern299 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern300 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12405 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2649; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_117 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern180 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern279 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11345 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2592; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11363 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2593; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern279 (x7, 
E_SImode) != 0
                      || !
#line 11384 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2594; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2595; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2599; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2596; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2600; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2597; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2601; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2598; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2602; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_118 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 11996 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2629; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2525; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2526; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9964 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2527; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9964 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2528; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9978 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2529; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9978 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2530; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2560; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2604; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2605; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2606; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2607; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2608; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2609; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2610; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2611; /* pool_section_start */

                case 0L:
                  return 2612; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2616; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12474 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2653; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12482 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2654; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12530 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2658; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2665; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12520 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2657; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10738 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2561; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10767 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2562; /* *sibcall_brc */
          if (!
#line 10775 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2563; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2603; /* nop */

    case RETURN:
      if (!
#line 11794 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2617; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11794 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2618; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 12008 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2630; /* prefetch */

    default:
      return -1;
    }
}
