/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern22 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern22 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern22 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern22 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern22 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern22 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern22 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern22 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern22 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern22 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern51 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern51 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern95 (x5); /* [-1, 1] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern133 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern133 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern176 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern217 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern217 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern298 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1213; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1214; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1215; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1216; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1217; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1218; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1219; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1220; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1221; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1222; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1223; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1224; /* vec_widen_umult_odd_v4si */

    case 12:
      if (!
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1225; /* vec_widen_umult_odd_v1di */

    case 13:
      if (!(
#line 1747 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1226; /* vec_widen_umult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern183 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 481; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern183 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 482; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern183 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 483; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern183 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 484; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern183 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 485; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 543; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 544; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 545; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 546; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 547; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 548; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 549; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 550; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 551; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 552; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 553; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 554; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 555; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 556; /* *vec_setv2di */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode))))
                return -1;
              return 557; /* *vec_setv1sf */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 558; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 559; /* *vec_setv4sf */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode))))
                return -1;
              return 560; /* *vec_setv1df */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 561; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 562; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 563; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 564; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 565; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 566; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 567; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 568; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 569; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 570; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 571; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 572; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 573; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 574; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 575; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 576; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 577; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 578; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 579; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 580; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern171 (x2))
        {
        case 0:
          if (!(
#line 1665 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1803; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1665 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1804; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if (!(
#line 1723 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1807; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1723 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1808; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4313 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1920; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4313 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4313 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1922; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4313 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1923; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      if (pattern108 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1390; /* *vec_cmpgev1sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1397; /* *vec_cmpgev1sf_signaling_finite_nocc */

    case E_V2SImode:
      if (pattern108 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1391; /* *vec_cmpgev2sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1398; /* *vec_cmpgev2sf_signaling_finite_nocc */

    case E_V4SImode:
      if (pattern108 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1392; /* *vec_cmpgev4sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1399; /* *vec_cmpgev4sf_signaling_finite_nocc */

    case E_V1DImode:
      if (pattern108 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1393; /* *vec_cmpgev1df_signaling_nocc */
      if (!
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1400; /* *vec_cmpgev1df_signaling_finite_nocc */

    case E_V2DImode:
      if (pattern108 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1394; /* *vec_cmpgev2df_signaling_nocc */
      if (!
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1401; /* *vec_cmpgev2df_signaling_finite_nocc */

    case E_V1TImode:
      if (pattern108 (x3, 
E_V1TFmode, 
E_V1TImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1395; /* *vec_cmpgev1tf_signaling_nocc */
      if (!(
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1402; /* *vec_cmpgev1tf_signaling_finite_nocc */

    case E_TImode:
      if (pattern108 (x3, 
E_TFmode, 
E_TImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1396; /* *vec_cmpgetf_signaling_nocc */
      if (!(
#line 2302 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1403; /* *vec_cmpgetf_signaling_finite_nocc */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern173 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern173 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern173 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern173 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 121; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern173 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 122; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern173 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern173 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern173 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 125; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern173 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 126; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern0 (x2, 
E_V1QImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 772; /* andv1qi3 */

            case E_V2QImode:
              if (pattern0 (x2, 
E_V2QImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 773; /* andv2qi3 */

            case E_V4QImode:
              if (pattern0 (x2, 
E_V4QImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 774; /* andv4qi3 */

            case E_V8QImode:
              if (pattern0 (x2, 
E_V8QImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 775; /* andv8qi3 */

            case E_V16QImode:
              if (pattern0 (x2, 
E_V16QImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 776; /* andv16qi3 */

            case E_V1HImode:
              if (pattern0 (x2, 
E_V1HImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 777; /* andv1hi3 */

            case E_V2HImode:
              if (pattern0 (x2, 
E_V2HImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 778; /* andv2hi3 */

            case E_V4HImode:
              if (pattern0 (x2, 
E_V4HImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 779; /* andv4hi3 */

            case E_V8HImode:
              if (pattern0 (x2, 
E_V8HImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 780; /* andv8hi3 */

            case E_V1SImode:
              if (pattern0 (x2, 
E_V1SImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 781; /* andv1si3 */

            case E_V2SImode:
              if (pattern0 (x2, 
E_V2SImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 782; /* andv2si3 */

            case E_V4SImode:
              if (pattern0 (x2, 
E_V4SImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 783; /* andv4si3 */

            case E_V1DImode:
              if (pattern0 (x2, 
E_V1DImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 784; /* andv1di3 */

            case E_V2DImode:
              if (pattern0 (x2, 
E_V2DImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 785; /* andv2di3 */

            case E_V1SFmode:
              if (pattern0 (x2, 
E_V1SFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 786; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern0 (x2, 
E_V2SFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 787; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern0 (x2, 
E_V4SFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 788; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern0 (x2, 
E_V1DFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 789; /* andv1df3 */

            case E_V2DFmode:
              if (pattern0 (x2, 
E_V2DFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 790; /* andv2df3 */

            case E_V1TFmode:
              if (pattern0 (x2, 
E_V1TFmode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 791; /* andv1tf3 */

            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 792; /* andv1ti3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0
                  || !
#line 1256 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 793; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 8146 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2355; /* *andhi3_zarch */
                }
              if (!
#line 8163 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2356; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 8191 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2357; /* *andqi3_zarch */
                }
              if (!
#line 8208 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2358; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4826 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 1998; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern222 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1369; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern222 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1370; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern222 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1371; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern222 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1372; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern222 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1373; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (pattern222 (x2, 
E_V1TImode, 
E_V1TFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1374; /* *vec_cmpeqv1tf_signaling_nocc */

        case E_TImode:
          if (pattern222 (x2, 
E_TImode, 
E_TFmode) != 0
              || !
#line 2268 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1375; /* *vec_cmpeqtf_signaling_nocc */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1573; /* *vevalv1qi_andand */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1582; /* *vevalv2qi_andand */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1591; /* *vevalv4qi_andand */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1600; /* *vevalv8qi_andand */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1609; /* *vevalv16qi_andand */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1618; /* *vevalv1hi_andand */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1627; /* *vevalv2hi_andand */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1636; /* *vevalv4hi_andand */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1645; /* *vevalv8hi_andand */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1654; /* *vevalv1si_andand */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1663; /* *vevalv2si_andand */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1672; /* *vevalv4si_andand */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1681; /* *vevalv1di_andand */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1690; /* *vevalv2di_andand */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1699; /* *vevalv1ti_andand */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1708; /* *vevalti_andand */

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1574; /* *vevalv1qi_andior */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1583; /* *vevalv2qi_andior */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1592; /* *vevalv4qi_andior */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1601; /* *vevalv8qi_andior */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1610; /* *vevalv16qi_andior */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1619; /* *vevalv1hi_andior */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1628; /* *vevalv2hi_andior */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1637; /* *vevalv4hi_andior */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1646; /* *vevalv8hi_andior */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1655; /* *vevalv1si_andior */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1664; /* *vevalv2si_andior */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1673; /* *vevalv4si_andior */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1682; /* *vevalv1di_andior */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1691; /* *vevalv2di_andior */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1700; /* *vevalv1ti_andior */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1709; /* *vevalti_andior */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1575; /* *vevalv1qi_andxor */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1584; /* *vevalv2qi_andxor */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1593; /* *vevalv4qi_andxor */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1602; /* *vevalv8qi_andxor */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1611; /* *vevalv16qi_andxor */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1620; /* *vevalv1hi_andxor */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1629; /* *vevalv2hi_andxor */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1638; /* *vevalv4hi_andxor */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1647; /* *vevalv8hi_andxor */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1656; /* *vevalv1si_andxor */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1665; /* *vevalv2si_andxor */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1674; /* *vevalv4si_andxor */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1683; /* *vevalv1di_andxor */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1692; /* *vevalv2di_andxor */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1701; /* *vevalv1ti_andxor */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1710; /* *vevalti_andxor */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x6, 0) != 8589934590L
              || !
#line 2116 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1829; /* *llxah_displacement_index */

        case 2L:
          if (XWINT (x6, 0) != 17179869180L
              || !
#line 2116 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1830; /* *llxaf_displacement_index */

        case 3L:
          if (XWINT (x6, 0) != 34359738360L
              || !
#line 2116 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1831; /* *llxag_displacement_index */

        case 4L:
          if (XWINT (x6, 0) != 68719476720L
              || !
#line 2116 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1832; /* *llxaq_displacement_index */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4843 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 1999; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern11 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 989; /* *ashlv1qi3 */
          if (!register_operand (operands[2], E_V1QImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1045; /* vashlv1qi3 */

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 993; /* *ashlv2qi3 */
          if (!register_operand (operands[2], E_V2QImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1046; /* vashlv2qi3 */

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 997; /* *ashlv4qi3 */
          if (!register_operand (operands[2], E_V4QImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1047; /* vashlv4qi3 */

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1001; /* *ashlv8qi3 */
          if (!register_operand (operands[2], E_V8QImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1048; /* vashlv8qi3 */

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1005; /* *ashlv16qi3 */
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1049; /* vashlv16qi3 */

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1009; /* *ashlv1hi3 */
          if (!register_operand (operands[2], E_V1HImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1050; /* vashlv1hi3 */

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1013; /* *ashlv2hi3 */
          if (!register_operand (operands[2], E_V2HImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1051; /* vashlv2hi3 */

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1017; /* *ashlv4hi3 */
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1052; /* vashlv4hi3 */

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1021; /* *ashlv8hi3 */
          if (!register_operand (operands[2], E_V8HImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1053; /* vashlv8hi3 */

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1025; /* *ashlv1si3 */
          if (!register_operand (operands[2], E_V1SImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1054; /* vashlv1si3 */

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1029; /* *ashlv2si3 */
          if (!register_operand (operands[2], E_V2SImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1055; /* vashlv2si3 */

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1033; /* *ashlv4si3 */
          if (!register_operand (operands[2], E_V4SImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1056; /* vashlv4si3 */

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1037; /* *ashlv1di3 */
          if (!register_operand (operands[2], E_V1DImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1057; /* vashlv1di3 */

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1041; /* *ashlv2di3 */
          if (!register_operand (operands[2], E_V2DImode)
              || !
#line 1548 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1058; /* vashlv2di3 */

        case 14:
          if (
#line 9686 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2504; /* *ashldi3_31 */
          if (!
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2506; /* *ashldi3 */

        case 15:
          return 2508; /* *ashlsi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2059 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1812; /* *lxah_index */

            case 2L:
              if (!
#line 2059 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1813; /* *lxaf_index */

            case 3L:
              if (!
#line 2059 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1814; /* *lxag_index */

            case 4L:
              if (!
#line 2059 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1815; /* *lxaq_index */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1816; /* *lxah_displacement_index */

            case 2L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1817; /* *lxaf_displacement_index */

            case 3L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1818; /* *lxag_displacement_index */

            case 4L:
              if (!
#line 2069 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1819; /* *lxaq_displacement_index */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1916 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1243; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1916 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1244; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1916 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1245; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 1916 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1246; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2495; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2496; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2497; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2498; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 953; /* ctzv1qi2 */

    case 1:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 954; /* ctzv2qi2 */

    case 2:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 955; /* ctzv4qi2 */

    case 3:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 956; /* ctzv8qi2 */

    case 4:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 957; /* ctzv16qi2 */

    case 5:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 958; /* ctzv1hi2 */

    case 6:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 959; /* ctzv2hi2 */

    case 7:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 960; /* ctzv4hi2 */

    case 8:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 961; /* ctzv8hi2 */

    case 9:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 962; /* ctzv1si2 */

    case 10:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 963; /* ctzv2si2 */

    case 11:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 964; /* ctzv4si2 */

    case 12:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 965; /* ctzv1di2 */

    case 13:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 966; /* ctzv2di2 */

    case 14:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 967; /* ctzv1sf2 */

    case 15:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 968; /* ctzv2sf2 */

    case 16:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 969; /* ctzv4sf2 */

    case 17:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 970; /* ctzv1df2 */

    case 18:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 971; /* ctzv2df2 */

    case 19:
      if (!
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 972; /* ctzv1tf2 */

    case 20:
      if (!(
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 973; /* ctzv1ti2 */

    case 21:
      if (!(
#line 1445 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 974; /* ctzti2 */

    case 22:
      if (!
#line 9633 "../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
        return -1;
      return 2501; /* ctzdi2 */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (pattern290 (x10, 
E_DImode) != 0
          || !
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2533; /* *brx_stage1_di */

    case E_SImode:
      if (pattern290 (x10, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2534; /* *brx_stage1_si */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern121 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 8146 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2355; /* *andhi3_zarch */
      if (!
#line 8163 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2356; /* *andhi3_esa */

    case E_QImode:
      if (pattern121 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 8191 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2357; /* *andqi3_zarch */
      if (!
#line 8208 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2358; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern38 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2582 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1851; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_92 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_93 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_94 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0
              || !
#line 7954 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2342; /* *anddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 8083 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2353; /* *andsi3_zarch */
          if (!
#line 8117 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2354; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern38 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4397 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1945; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern89 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4843 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 1999; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern246 (x3, 
E_DImode) != 0
                  || !(
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2344; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern246 (x3, 
E_SImode) != 0
                  || !
#line 8004 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2346; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern246 (x3, 
E_DImode) != 0
              || !(
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2348; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern246 (x3, 
E_SImode) != 0
              || !
#line 8018 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2350; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2359; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2381; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8226 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2360; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8605 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2383; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x3))
            {
            case 0:
              if (!(
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2393; /* *nordi */

            case 1:
              if (!
#line 8645 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2395; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern250 (x4, 
E_DImode) != 0
                  || !(
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1975; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern250 (x4, 
E_SImode) != 0
                  || !
#line 4678 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1977; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4693 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1979; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1981; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4708 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1983; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1985; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4728 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1987; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4746 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1989; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4746 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1991; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4765 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1993; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4765 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1995; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4785 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1997; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8941 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2408; /* *xc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8785 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2402; /* *xordi3 */

        case 1:
          if (!
#line 8855 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2405; /* *xorsi3 */

        case 2:
          if (!
#line 8888 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2406; /* *xorhi3 */

        case 3:
          if (!
#line 8918 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2407; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern98 (x4) != 0)
            return -1;
          switch (pattern258 (x1))
            {
            case 0:
              if (!(
#line 3691 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1888; /* *cpymem_long */

            case 1:
              if (!(
#line 3691 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1889; /* *cpymem_long */

            case 2:
              if (!
#line 3704 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1890; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern296 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4144 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1910; /* *cmpmem_long */

                case E_DImode:
                  if (pattern296 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4144 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1911; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4157 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1912; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3842 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1900; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3842 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1901; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2661; /* split_stack_calldi */

            case 1:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2662; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2663; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 775 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2664; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_153 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_207 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_243 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_261 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_270 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_279 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_145 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_154 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_163 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_262 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_271 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_280 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_164 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_263 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_281 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern181 (x3, 
E_DImode) != 0
              || !(
#line 4624 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 768 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_342 (insn, operands);

        case E_SImode:
          if (pattern181 (x3, 
E_SImode) != 0
              || !
#line 4624 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_343 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern197 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3135 "../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
